from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, String, Boolean, File

Blat2Hints_Pl_V0_1_0 = CommandToolBuilder(tool="blat2hints.pl", base_command=["blat2hints.pl"], inputs=[ToolInput(tag="in_priority", input_type=Int(optional=True), prefix="--priority", doc=InputDocumentation(doc="priority of hint group (default 4)")), ToolInput(tag="in_max_gap_len", input_type=Int(optional=True), prefix="--maxgaplen", doc=InputDocumentation(doc="gaps at most this length are simply closed (default 14)")), ToolInput(tag="in_min_intron_len", input_type=Int(optional=True), prefix="--minintronlen", doc=InputDocumentation(doc="alignments with gaps shorter than this and longer than maxgaplen are discarded (default 41)")), ToolInput(tag="in_max_intron_len", input_type=Int(optional=True), prefix="--maxintronlen", doc=InputDocumentation(doc="alignments with longer gaps are discarded (default 350000)")), ToolInput(tag="in_maxq_gap_len", input_type=Int(optional=True), prefix="--maxQgaplen", doc=InputDocumentation(doc="maximum length of gap in query (cDNA) sequence (default 5)")), ToolInput(tag="in_ep_cut_off", input_type=Int(optional=True), prefix="--ep_cutoff", doc=InputDocumentation(doc="this many bp are cut off of each exonpart hint at end of alignment (default 10)")), ToolInput(tag="in_source", input_type=String(optional=True), prefix="--source", doc=InputDocumentation(doc="source identifier (default 'E')")), ToolInput(tag="in_introns_only", input_type=Boolean(optional=True), prefix="--intronsonly", doc=InputDocumentation(doc="only retrieve intron hints (e.g. because the exon(part) hints are retrieved by converting to a wig track, default: off)")), ToolInput(tag="in_no_mult", input_type=Boolean(optional=True), prefix="--nomult", doc=InputDocumentation(doc="do not summarize multiple identical intron hints to a single one")), ToolInput(tag="in_remove_redundant", input_type=String(optional=True), prefix="--remove_redundant", doc=InputDocumentation(doc="keep the strongest hint for a region (default false)")), ToolInput(tag="in_max_coverage", input_type=Int(optional=True), prefix="--maxcoverage", doc=InputDocumentation(doc="maximal number of hints at a given position. A high value causes long running time of\nAUGUSTUS in regions with thousands of cDNA alignments. (default 3000)")), ToolInput(tag="in_ss_on", input_type=Boolean(optional=True), prefix="--ssOn", doc=InputDocumentation(doc="include splice site (dss, ass) hints in output (default false)")), ToolInput(tag="in_trunks_s", input_type=Boolean(optional=True), prefix="--trunkSS", doc=InputDocumentation(doc="include splice sites hints from the ends of a truncated alignment (contig too short)")), ToolInput(tag="in_col_offset", input_type=Int(optional=True), prefix="--coloffset", doc=InputDocumentation(doc="column offset, 0 for direct blat output, 1 for psl format from UCSC database (default 0)")), ToolInput(tag="in_score", input_type=Int(optional=True), prefix="--score", doc=InputDocumentation(doc="fill this number in in the score column (default 0)")), ToolInput(tag="in_clone_file", input_type=File(optional=True), prefix="--clonefile", doc=InputDocumentation(doc="provide a file with clone names so close alignments from the same clone can be grouped.\nAUGUSTUS will try to put those hints into a single transcripts even if different ends of\nthe clones were sequenced. File format (tab delimited):\ncloneA     read1   read2\ncloneA     read3\ncloneB     read4   read5")), ToolInput(tag="in_terminus_file", input_type=File(optional=True), prefix="--terminusfile", doc=InputDocumentation(doc="provide a file with EST terminus information to infer tss/tts hints.\nAUGUSTUS will use tss/tts hints to predict transcription start/termination sites\nFile format (tab delimited):\n# ESTname    EstDir    Type FrontTerminus  EndTerminus\nCACW5781.b1     5       A2      5TSS       Unknown\nCACW6759.g1     3       F23     5TNS       3TNS\nCACW14459.g2    3       D2      Unknown    3TNS\nCACW21662.g1    3       C2      5TNS       Unknown\nCACW25491.g1    3       F21     5TNS       3TNS-NP\ncloneB     read4   read5")), ToolInput(tag="in_max_gene_len", input_type=Int(optional=True), prefix="--maxgenelen", doc=InputDocumentation(doc="alignments of the same clone are considered to be of the same gene if not separated by more than this (400000)\nAlignments that span more than this are ignored, but better filter long introns through alignment program.\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Blat2Hints_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

